import { world, ItemStack, system } from '@minecraft/server'

world.afterEvents.playerJoin.subscribe(eventData => {
    system.runTimeout(() => {
        world.getDimension('overworld').runCommand(`give @a[tag =! guideCB] twm:cobblestone_generators_book_0`)
        world.getDimension('overworld').runCommand(`tag @a add guideCB`)
    }, Math.PI * 20);
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.itemComponentRegistry.registerCustomComponent('twm:cobblestone_generators_book', {
        onUse(e) {
            const { itemStack, source } = e
            const book = itemStack.typeId
            const { identifier, page } = bookinfo(book)
            const slot = source.selectedSlotIndex
            const playerInv = source.getComponent('minecraft:inventory').container
            const location = source.location
            if (!source.isSneaking && page < 4) {
                playerInv.setItem(slot, new ItemStack(`${identifier}_${page + 1}`, 1))
                world.playSound("item.book.page_turn", location)

            }
            if (source.isSneaking && page > 0) {
                playerInv.setItem(slot, new ItemStack(`${identifier}_${page - 1}`, 1))
                world.playSound("item.book.page_turn", location)


            }
        }
    })
})

function bookinfo(book) {
    const lastUnderscoreIndex = book.lastIndexOf('_');

    const identifier = book.slice(0, lastUnderscoreIndex);
    const page = parseInt(book.slice(lastUnderscoreIndex + 1));

    return { identifier, page };
}